/* ***** BEGIN LICENSE BLOCK *****
 * Version: MPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Mozilla Public License Version
 * 1.1 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 * http://www.mozilla.org/MPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is mozilla.org view-source front-end.
 *
 * The Initial Developer of the Original Code is mozilla.org.
 * Portions created by the Initial Developer are Copyright (C) 2002
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *   Jeroen Groenenboom <jagrboom@zonnet.nl> (Original Author)
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the MPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the MPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

var bMHPrefsWindow = {

init: function() {
	  var field;
	  for( var i = 0; i < bMHPrefs.defaults.length; i++ ) {
	      field = document.getElementById( bMHPrefs.defaults[i].name );
	      field.value = bMHPrefs.getPref( bMHPrefs.defaults[i].name );
	  }
      },

reset: function() {
	   var field;
	   for( var i = 0; i < bMHPrefs.defaults.length; i++ ) {
	      field = document.getElementById( bMHPrefs.defaults[i].name );
	      field.value = bMHPrefs.defaults[i].value;
	   }
       },

cancel: function() {
	    window.close();
	},

save: function() {
	  var fields = new Array( bMHPrefs.defaults.length );
	  var values = new Array( bMHPrefs.defaults.length );
	  var i;
	  for( i = 0; i < fields.length; i++ ) {
	      fields[i] = document.getElementById( bMHPrefs.defaults[i].name );
	      values[i] = bMHPrefsWindow.parseValue( fields[i].value, bMHPrefs.defaults[i] ); 
	      if( values[i] == -1 ) {
		  alert( fields[i].id + ' does not have a proper value' );
		  return;
	      }
	  }
	  for( i = 0; i < fields.length; i++ ) {
	      bMHPrefs.setPref( fields[i].id, bMHPrefs.defaults[i].type, values[i] );
	  }
	  window.opener.parent.location.reload();
      },

parseValue: function( value, dflt ) {
		if( dflt.type == 64 ) {
		    value = parseInt( value );
		    if( isNaN( value ) ||
			    value < 0 ||
			    ( value == 0 && 
			      (dflt.name == "nrOfColumns" || 
			       dflt.name == "maxNameLength" ))) {
			return -1;
		    }
		}
		return value;
	    },
}



